- 1. Build Integration: Integrate Standard Checkout form on website.
- 2. Test Integration: Test the integration by making a test payment.
- 3. Go-live Checklist: Check the go-live checklist.
1. Build Integration
Follow the steps given below:1.1 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
Handy TipsUnder the Authorization section in Postman, select Basic Auth and add the Key Id and secret as the Username and Password, respectively.You can create an order manually by integrating the API sample codes on your server.Request Parameters
amount mandatory
: integer The transaction amount, expressed in the currency subunit. For example, for an actual amount of , the value of this field should be 22225.currency mandatory
: string The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Response Parameters
Descriptions for the response parameters are present in the Orders Entity parameters table.Error Response Parameters
The error response parameters are available in the API Reference Guide.1.2 Pass Order ID and Other Options to Checkout
- This integration method provides a default Pay with Razorpay button that invokes the Checkout form.
- Pass Checkout form options as data attributes inside a “ tag. You can add any additional hidden or visible fields to the form, which will be submitted along with the form.
-
Send Checkout options as form-data to the following URL in a POST request.
1.2.1 Code to Add Pay Button
/https://www.example.com/success/
The following sample code passes the Razorpay checkout options as HTML data attributes:
Quick Integration
1.2.2 Handle Payment Success and Failure
The way the payment success and failure scenarios are handled depends on the Checkout Sample Code you used in the previous step.On Payment Success
Razorpay makes a POST call to the callback URL with the razorpay_payment_id, razorpay_order_id and razorpay_signature in the response object of the successful payment. Only successful authorisations are auto-submitted.On Payment Failure
In case of failed payments, the checkout is displayed again to facilitate payment retry.1.2.3 Checkout Options
data-key mandatory
: string API Key ID generated from the Razorpay Dashboard.
data-amount mandatory
: integer The amount to be paid by the customer in cents. For example, if the amount is 500, enter 50000.
data-currency mandatory
: string The currency in which the payment should be made by the customer. See the list of supported currencies
data-order_id mandatory
: string Unique identifier of the Order generated in Step 1: Create an Order in your Server.
data-buttontext mandatory
: string The text you want to display on the button. For example, Buy Now!.
data-name mandatory
: string Your Business/Enterprise name shown on the Checkout form. For example, Acme Corp.
data-description optional
: string Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.
data-image mandatory
: string Link to an image (usually your business logo) shown on the Checkout form. Can also be a base64 string if you are not loading the image from a network.
data-prefill.name optional
: string Cardholder’s name to be pre-filled when the Checkout opens.
data-prefill.email optional
: string Customer’s email to be pre-filled when the Checkout opens.
data-prefill.contact optional
: string Customer’s phone number to be pre-filled when the Checkout opens.
data-theme.color optional
: string Brand color to alter the appearance of Checkout form. For example, #F37254.
Know more about the complete list of available Checkout options.
1.3 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form. Success Callback- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
Success Callback
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.
razorpay_order_id
: string Unique identifier for the order returned by Checkout.
razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.
1.4 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments. To verify therazorpay_signature returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:HMAC Hex Digest -
If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Given below is the sample code for payment signature verification:Java
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs. Here are the links to our SDKs for the supported platforms.1.6 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:To verify the payment status from the Razorpay Dashboard:- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Example
If you have subscribed to theorder.paid webhook event, you will receive a notification every time a customer pays you for an order.Poll Payment APIs to check the payment status.2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app. Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful.Netbanking
You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.
Check the list of supported banks.
UPI
You can enter one of the following UPI IDs:success@razorpay: To make the payment successful.failure@razorpay: To fail the payment.
Handy TipsYou can use Test Mode to test UPI payments, and Live Mode for UPI Intent and QR payments.
Cards
You can use the following test cards to test transactions for your integration in Test Mode.Domestic Cards
Use the following test cards for Indian payments:Network | Card Number | CVV & Expiry Date
Visa | 4100 2800 0000 1007 | Use a random CVV and any future date ^^^^^
Mastercard | 5500 6700 0000 1002 |
RuPay | 6527 6589 0000 1005 |
Diners | 3608 280009 1007 |
Amex | 3402 560004 01007 |Error Scenarios
Use these test cards to simulate payment errors. See the complete list of error test cards with detailed scenarios. Check the following lists:International Cards
Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.Card Network | Card Number | CVV & Expiry Date
Mastercard | 5555 5555 5555 4444 5105 1051 0510 5100 5104 0600 0000 0008 | Use a random CVV and any future date ^^
Visa | 4012 8888 8888 1881 | Check the list of supported card networks.Wallet
You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.
Check the list of supported wallets.
3. Go-live Checklist
Check the go-live checklist for Razorpay Web Standard Checkout integration. Consider these steps before taking the integration live.3.1 Accept Live Payments
Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.3.2 Payment Capture
After payment isauthorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.